define(['testsuite/qunit', 'jquery', 'ep/date'], function (QUnit, $, ep) {

	QUnit.module("ep/date");

	QUnit.asyncTest("ep/date", function() {

		var date = new ep.Date(2012,0,1,5,5,5);
	
		QUnit.deepEqual(
	
			date.isLeapYear(),
			true,
			"date.isLeapYear()"
		);
		QUnit.deepEqual(
			date.getMonthLength(),
			31,
			"date.getMonthLength()"
		);
	
		QUnit.deepEqual(
			date.compareDate( new Date(2012,1,1) ),
			-1,
			"date.compareDate( new Date(2012,1,1) )"
		);
		QUnit.deepEqual(
			 date.compareDate( new Date(2011,1,1) ),
			 1,
			 "date.compareDate( new Date(2011,1,1) )"
		);
		QUnit.deepEqual(
			 date.compareDate( new Date(2012,0,1,5,5,5) ),
			 0,
			 "date.compareDate( new Date(2012,0,1,5,5,5) )"
		);
		QUnit.deepEqual(
			date.compareTime( new Date(2010,0,1,13,37,8) ),
			-1,
			"date.compareTime( new Date(2010,0,1,13,37,8) )"
		);
		QUnit.deepEqual(
			date.compareTime( new Date(2010,0,1,4,35,10) ),
			1,
			"date.compareTime( new Date(2010,0,1,4,35,10) )"
		);
		QUnit.deepEqual(
			date.compareTime( new Date(2010,0,1,5,5,5) ),
			0,
			"date.compareTime( new Date(2010,0,1,5,5,5) )"
		);
	
		QUnit.deepEqual(
			date.addHours(1).getTime(),
			new Date(2012,0,1,6,5,5).getTime(),
			"date.addHours(1)"
		);
		QUnit.deepEqual(
			new ep.Date(2012,0,1,23,55,0).addHours(2).getTime(),
			new Date(2012,0,2,1,55,0).getTime(),
			"new ep.Date(2012,0,1,23,55,0).addHours(2)"
		);
		QUnit.deepEqual(
			new ep.Date(2012,11,31,23,59,0).addHours(2).getTime(),
			new Date(2013,0,1,1,59,0).getTime(),
			"new ep.Date(2012,11,31,23,59,0).addHours(2)"
		);
	
		QUnit.deepEqual(
			date.addMinutes(1).getTime(),
			new Date(2012,0,1,6,6,5).getTime(),
			"date.addMinutes(1)"
		);
		QUnit.deepEqual(
			new ep.Date(2012,0,1,23,55,0).addMinutes(6).getTime(),
			new Date(2012,0,2,0,1,0).getTime(),
			"new ep.Date(2012,0,1,23,55,0).addMinutes(6)"
		);
		QUnit.deepEqual(
			new ep.Date(2012,11,31,23,59,0).addMinutes(2).getTime(),
			new Date(2013,0,1,0,1,0).getTime(),
			"new ep.Date(2012,11,31,23,59,0).addMinutes(2)"
		);
	
		QUnit.deepEqual(
			date.addSeconds(1).getTime(),
			new Date(2012,0,1,6,6,6).getTime(),
			"date.addSeconds(1)"
		);
		QUnit.deepEqual(
			new ep.Date(2012,0,1,23,59,59).addSeconds(6).getTime(),
			new Date(2012,0,2,0,0,5).getTime(),
			"new ep.Date(2012,0,1,23,59,59).addSeconds(6)"
		);
		QUnit.deepEqual(
			new ep.Date(2012,11,31,23,59,59).addSeconds(2).getTime(),
			new Date(2013,0,1,0,0,1).getTime(),
			"new ep.Date(2012,11,31,23,59,59).addSeconds(2)"
		);
	
		QUnit.deepEqual(
			date.addDate(1).getTime(),
			new Date(2012,0,2,6,6,6).getTime(),
			"date.addDate(1)"
		);
		QUnit.deepEqual(
			new ep.Date(2012,0,31).addDate(2).getTime(),
			new Date(2012,1,2).getTime(),
			"new ep.Date(2012,0,31).addDate(2)"
		);
		QUnit.deepEqual(
			new ep.Date(2012,11,31).addDate(2).getTime(),
			new Date(2013,0,2).getTime(),
			"new ep.Date(2012,11,31).addDate(2)"
		);
	
		QUnit.deepEqual(
			date.addMonth(1).getTime(),
			new Date(2012,1,2,6,6,6).getTime(),
			"date.addMonth(1)"
		);
		QUnit.deepEqual(
			new ep.Date(2012,10,1).addMonth(2).getTime(),
			new Date(2013,0,1).getTime(),
			"new ep.Date(2012,10,1).addMonth(2)"
		);
		QUnit.deepEqual(
			new ep.Date(2012,11,31).addMonth(2).getTime(),
			new Date(2013,1,31).getTime(),
			"new ep.Date(2012,11,31).addMonth(2)"
		);
	
		QUnit.deepEqual(
			date.addFullYear(1).getTime(),
			new Date(2013,1,2,6,6,6).getTime(),
			"date.addFullYear(1)"
		);
		QUnit.deepEqual(
			new ep.Date(2012,10,1).addFullYear(2).getTime(),
			new Date(2014,10,1).getTime(),
			"new ep.Date(2012,10,1).addFullYear(2)"
		);
		QUnit.deepEqual(
			new ep.Date(2012,11,31).addFullYear(2).getTime(),
			new Date(2014,11,31).getTime(),
			"new ep.Date(2012,11,31).addFullYear(2)"
		);
	
		QUnit.deepEqual(
			date.diffDate( new Date(2013,1,2,6,6,6) ),
			0,
			"date.diffDate( new Date(2013,1,2,6,6,6) )"
		);
		QUnit.deepEqual(
			date.diffDate( new Date(2013,1,3,6,6,6) ),
			1,
			"date.diffDate( new Date(2013,1,3,6,6,6) )"
		);
		QUnit.deepEqual(
			date.diffDate( new Date(2013,1,3,8,6,1) ),
			1,
			"date.diffDate( new Date(2013,1,3,8,6,1) )"
		);
		QUnit.deepEqual(
			date.diffDate( new Date(2013,1,3,18,6,6) ),
			2,
			"date.diffDate( new Date(2013,1,3,18,6,6) )"
		);
		QUnit.deepEqual(
			date.diffDate( new Date(2013,1,0,18,6,6) ),
			-1,
			"date.diffDate( new Date(2013,1,0,18,6,6) )"
		);
	
		QUnit.deepEqual(
			date.diffHours( new Date(2013,1,2,6,6,1) ),
			0,
			"date.diffHours( new Date(2013,1,2,6,6,1) )"
		);
		QUnit.deepEqual(
			date.diffHours( new Date(2013,1,3,0,6,1) ),
			18,
			"date.diffHours( new Date(2013,1,3,0,6,1) )"
		);
		QUnit.deepEqual(
			date.diffHours( new Date(2013,1,3,8,25,1) ),
			26,
			"date.diffHours( new Date(2013,1,3,8,25,1) )"
		);
		QUnit.deepEqual(
			date.diffHours( new Date(2013,1,3,17,0,1) ),
			35,
			"date.diffHours( new Date(2013,1,3,17,0,1) )"
		);
		QUnit.deepEqual(
			date.diffHours( new Date(2013,1,2,2,0,1) ),
			-4,
			"date.diffHours( new Date(2013,1,2,2,0,1) )"
		);
	
		QUnit.deepEqual(
			date.diffMinutes( new Date(2013,1,2,6,6,6) ),
			0,
			"date.diffMinutes( new Date(2013,1,2,6,6,6) )"
		);
		QUnit.deepEqual(
			date.diffMinutes( new Date(2013,1,3,0,6,6) ),
			1080,
			"date.diffMinutes( new Date(2013,1,3,0,6,6) )"
		);
		QUnit.deepEqual(
			date.diffMinutes( new Date(2013,1,3,8,25,6) ),
			1579,
			"date.diffMinutes( new Date(2013,1,3,8,25,6) )"
		);
		QUnit.deepEqual(
			date.diffMinutes( new Date(2013,1,3,17,0,6) ),
			2094,
			"date.diffMinutes( new Date(2013,1,3,17,0,6) )"
		);
		QUnit.deepEqual(
			date.diffMinutes( new Date(2013,1,2,1,0,6) ),
			-306,
			"date.diffMinutes( new Date(2013,1,2,1,0,6) )"
		);
	
		QUnit.deepEqual(
			new ep.Date().diffDate(),
			0,
			"new ep.Date().diffDate()"
		);
	
		QUnit.deepEqual(
			new ep.Date(2010,1,12).setLastMonthDay().getDate(),
			28,
			"new ep.Date(2010,1,12).setLastMonthDay().getDate()"
		);
	
		QUnit.deepEqual(
			new ep.Date(2010,1,12).setLastMonthDay().getDate(),
			28,
			"new ep.Date(2010,1,12).setLastMonthDay().getDate()"
		);
	
		QUnit.deepEqual(
			new ep.Date().setUnixTime(1264978800).getFullYear(),
			2010,
			"new ep.Date().setUnixTime(1264978800).getFullYear()"
		);
	
		QUnit.deepEqual(
			new ep.Date(2010,1,12).setDay(4).getDate(),
			11,
			"new ep.Date(2010,1,1).setDay(4).getDate()"
		);
	
		QUnit.deepEqual(
			new ep.Date(2008,1,12).getMonthLength(),
			29,
			"new ep.Date(2008,1,12).getMonthLength()"
		);
	
		QUnit.start();
	});

});

