/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			ep.i18n
 *
 * @revision		$Revision: 1.5 $
 */

define("ep/i18n", [
	"jquery",
	"ep",

	"jquery/i18n"
], function ($, ep){

	$.extend((ep.i18n = {}),{

		formatBytes: function( value, decimals, options ){
			if( typeof decimals !== 'number' ){
				if( !options ){
					options = decimals;
				}
				decimals = 2;
			}

			var unit = 'Byte';

			if( value >= 1073741824 ) {
				value /= 1073741824;
				unit = 'GB';
			}
			else if( value >= 1048576 ) {
				value /= 1048576;
				unit = 'MB';
			}
			else if( value >= 1024 ) {
				value /= 1024;
				unit = 'kB';
			}

			return $.i18n.formatNumber( value, 'n'+decimals, options ) + ' ' + unit;
		}

	});

	return ep;

});