define(['testsuite/qunit', 'jquery', 'ep/ui/mobileslides', '$ready!'], function (QUnit, $, ep) {

	QUnit.module("ep/ui/mobileslides");

	QUnit.asyncTest("ep/ui/mobileslides", function() {

		var slides = $('#slides')
				.mobileSlides({
					images: '#images img'
				}),
			slideHead = $('.ep-mobileSlides-head'),
			slideBody = $('.ep-mobileSlides-body'),
			slideFoot = $('.ep-mobileSlides-foot'),
			slideBack = slideHead.find('.ep-mobileSlides-back'),
			slideCount = slideHead.find('.ep-mobileSlides-count'),
			slideFullsize = slideHead.find('.ep-mobileSlides-fullsize');

		QUnit.equal(
			slideHead.length,
			1,
			"Head area of exists."
		);

		QUnit.equal(
			slideBody.length,
			1,
			"Body area of exists."
		);

		QUnit.equal(
			slideFoot.length,
			1,
			"Foot area of exists."
		);

		QUnit.equal(
			slideBack.length,
			1,
			"back link in head area of exists."
		);

		QUnit.equal(
			slideCount.length,
			1,
			"Counter in head area of exists."
		);

		QUnit.equal(
			slideFullsize.length,
			1,
			"Fullsize link in head area of exists."
		);

		QUnit.equal(
			slideBody.is(':visible'),
			false,
			"Slideshow is visible?"
		);

		QUnit.equal(
			slideBody.find("li").length,
			8,
			"Count of content boxes (for images) in body"
		);

		QUnit.equal(
			slideFoot.find("li").length,
			8,
			"Count of content boxes (for images) in foot"
		);

		slides.trigger('click');

		QUnit.equal(
			slideBody.is(':visible'),
			true,
			"Slideshow is visible, after trigger click on widget applied element?"
		);

		setTimeout(function(){
			slideBack.trigger('click');

			QUnit.equal(
				$('.ep-mobileSlides:visible').length,
				0,
				"Slideshow no longer visible after trigger click 'back'."
			);

			slides.mobileSlides('destroy');

			QUnit.equal(
				$('.ep-mobileSlides').length,
				0,
				"Slideshow no longer exists after 'destroy'."
			);

			QUnit.start();

		}, 1200);

	});
});