/*
 * @copyright		© Copyright 2006-2012, epages GmbH, All Rights Reserved.
 *
 * @module			ep.ui.slidebox
 *
 * @revision		$Revision: 1.11 $
 */

define("ep/ui/slidebox", [
	"jquery",
	"ep",
	"vendor/swiper",
	
	"jquery/ui/widget"
], function ($, ep, Swiper) {

	$.widget( "ui.uiSlidebox", {
		options: {
			view	: 2,
			arrow	: true,
			speed	: 300
		},

		_create: function(){
			var self = this,

				o = self.options,

				slides,

				swiper,

				_updateActiveSlide;

			self.container = self.element
				.addClass("swiper-container ep-uislidebox");

			self.wrapper = self.container
				.children()
				.addClass("swiper-wrapper");

			self.slides = slides = self.wrapper
				.children()
				.addClass("swiper-slide");

			self.swiper = swiper = new Swiper(self.container[0], {
				speed: o.speed,
				slidesPerSlide: o.view
			});

			// Hook swiper for event trigger
			_updateActiveSlide = swiper.updateActiveSlide;

			swiper.updateActiveSlide = function () {
				var result = _updateActiveSlide.apply(this, arguments);

				self.element.trigger("changeslide", {
					slide: swiper.realIndex + 1,
					slides: slides.length
				});

				return result;
			};
		},

		_init: function () {
			// Refresh sizes on init
			this.swiper.resizeFix();
		},

		goTo: function (i) {
			var swiper = this.swiper;

			if (i == 'next') {
				swiper.swipeNext();
			}
			else if (i == 'prev') {
				swiper.swipePrev();
			}
			else{
				swiper.swipeTo(i - 1);
			}
		},

		destroy: function () {
			var self = this;

			self.container.removeClass("swiper-container ep-uislidebox");
			self.wrapper.removeClass("swiper-wrapper");
			self.slides.removeClass("swiper-slide");

			self.swiper.destroy();

			self._superApply(arguments);
		}
	});

	return ep;

});