define(['testsuite/qunit', 'jquery', 'ep/ui/slides', '$ready!'], function (QUnit, $, ep) {

	QUnit.module("ep/ui/slides");

	QUnit.asyncTest("ep/ui/slides", function() {

		var t,

			slides01 = ep('#slides01')
				.uiSlides({
					images	: '#images img',
					action	: "lightbox",
					caption	: true,
					count	: true,
					delay	: 500,
					autoplay: true
				}),

			imgData = ep.ui.imgData('#images img')
				.on('lightbox',function(){
					t = this.current();
				});

		setTimeout(function () {

			QUnit.equal(
				slides01.find('img').length,
				1,
				"ep('#slides01 img').length"
			);

			QUnit.equal(
				imgData.current().desc,
				"Bild 1",
				"ep.ui.imgData('#images img').current().desc"
			);

			QUnit.equal(
				imgData.current().src,
				"slides-test-image1.jpg",
				"ep.ui.imgData('#images img').current().src"
			);

			QUnit.equal(
				slides01.find('img').attr('src'),
				"slides-test-image1.jpg",
				"ep('#slides01 img').attr('src')"
			);

			setTimeout(function () {

				QUnit.equal(
					slides01.find('img').length,
					2,
					"ep('#slides01 img').length"
				);

				QUnit.equal(
					imgData.current().desc,
					"Bild 2",
					"ep.ui.imgData('#images img').current().desc"
				);

				QUnit.equal(
					imgData.current().src,
					"slides-test-image2.jpg",
					"ep.ui.imgData('#images img').current().src"
				);

				QUnit.equal(
					slides01.find('img').attr('src'),
					"slides-test-image2.jpg",
					"ep('#slides01 img').attr('src')"
				);

				slides01.find('.ep-uiSlides').trigger('click');

				imgData.current(3);

				QUnit.equal(
					imgData.current().desc,
					"Bild 4",
					"ep.ui.imgData('#images img').current().desc"
				);

				QUnit.equal(
					imgData.current().src,
					"slides-test-image2.jpg",
					"ep.ui.imgData('#images img').current().src"
				);

				setTimeout(function () {

					QUnit.equal(
						slides01.find('img').attr('src'),
						"slides-test-image2.jpg",
						"ep('#slides01 img').attr('src')"
					);

					slides01.find('.ep-uiSlides-ctrlNext a').trigger('click');

					QUnit.equal(
						imgData.current().desc,
						"Bild 5",
						"ep.ui.imgData('#images img').current().desc"
					);

					QUnit.equal(
						imgData.current().src,
						"slides-test-image1.jpg",
						"ep.ui.imgData('#images img').current().src"
					);

					setTimeout(function () {

						QUnit.equal(
							slides01.find('img').attr('src'),
							"slides-test-image1.jpg",
							"ep('#slides01 img').attr('src')"
						);

						slides01.find('.ep-uiSlides').trigger('touchswipeleft');

						QUnit.equal(
							imgData.current().desc,
							"Bild 6",
							"ep.ui.imgData('#images img').current().desc"
						);

						QUnit.equal(
							imgData.current().src,
							"slides-test-image2.jpg",
							"ep.ui.imgData('#images img').current().src"
						);

						setTimeout(function () {

							QUnit.equal(
								slides01.find('img').attr('src'),
								"slides-test-image2.jpg",
								"ep('#slides01 img').attr('src')"
							);

							slides01.find('.ep-uiSlides-ctrlPrev a').trigger('click');

							QUnit.equal(
								imgData.current().desc,
								"Bild 5",
								"ep.ui.imgData('#images img').current().desc"
							);

							QUnit.equal(
								imgData.current().src,
								"slides-test-image1.jpg",
								"ep.ui.imgData('#images img').current().src"
							);

							setTimeout(function () {

								QUnit.equal(
									slides01.find('img').attr('src'),
									"slides-test-image1.jpg",
									"ep('#slides01 img').attr('src')"
								);

								slides01.find('.ep-uiSlides').trigger('touchswiperight');

								QUnit.equal(
									imgData.current().desc,
									"Bild 4",
									"ep.ui.imgData('#images img').current().desc"
								);

								QUnit.equal(
									imgData.current().src,
									"slides-test-image2.jpg",
									"ep.ui.imgData('#images img').current().src"
								);

								setTimeout(function () {

									QUnit.equal(
										slides01.find('img').attr('src'),
										"slides-test-image2.jpg",
										"ep('#slides01 img').attr('src')"
									);

									QUnit.start();

								},1000);

							},1000);

						},1000);

					},1000);

				},1000);

			}, 2500 );

		}, 500 );

	});
});