/*global define*/

define("de_epages/mediagallery/filemanager/file-model", [
	"backbone",
	"jquery",
	"ep",
	"./sync"
], function (Backbone, $, ep, filemanagerSync) {
    "use strict";

    var model = Backbone.Model.extend({
        sync: filemanagerSync,
        defaults: {
            modelType: "file",
            placeholder: ep.config.javascriptRoot + "/de_epages/mediagallery/images/placeholder.png"
        },

        initialize: function () {
            var displayableExtensions = [".jpg", ".jpeg", ".png", ".gif"],
                extension = this.get("extension");

            // check whether a file is displayable or not
            if ($.inArray(extension.toLowerCase(), displayableExtensions) === -1) {
                this.set({
                    preview: ep.config.javascriptRoot + "/de_epages/mediagallery/images/ico_unknowndocument.png",
                    largePreview: ep.config.javascriptRoot + "/de_epages/mediagallery/images/ico_unknowndocumentpreview.png",
                    icon: true
                });
            }
        }
    });

    return model;
});