/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.mediagallery.ui.filemanager
 *
 * @revision		$Revision: 1.5 $
 */

define("de_epages/mediagallery/ui/filemanager",[
	"jquery/ui/widget",
	"de_epages",
	"de_epages/mediagallery/filemanager"
], function ($, de_epages, filemanager) {


	$.widget("ui.mediagalleryUiFilemanager", {

		options: {
			accept:        "*/*",          // a string of MIME types and/or MIME type groups which will be accepted by the uploader
			selectable:    "image/",       // a string of MIME types and/or MIME type groups which can be selected
			currentFolder: "MediaGallery"  // root node of the opened folder
		},

		_create: function(){
			var self = this,
				o = self.options;

			self.filemanagerContainer = $('<div>').appendTo(self.element);
			$.extend(o, {element: self.filemanagerContainer});

			self.filemanager = filemanager.init(o);
		},

		getCurrentUsage: function(){
			return this.filemanager.getCurrentUsage();
		},

		getSelectedElements: function(){
			return this.filemanager.getSelectedElements();
		},

		destroy: function(){
			if (this.filemanagerContainer) {
				this.filemanagerContainer.remove();
			}
			this._superApply(arguments);
		}
	});

	return de_epages;
});
