/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.presentation.history
 *
 * @revision		$Revision: 1.5 $
 */

define("de_epages/presentation/history", [
	"jquery",
	"de_epages",
	"util/scope",
	"util/storage"
], function ($, de_epages, scope, storage) {

	var undef,

		historyData = storage.localStorage('history') || [],

		historySave = function(){
			storage.localStorage('history', historyData );
		},

		historyHandle = $.extend( scope('de_epages.presentation.history'), {

			add: function( add ){
				if( !add ){
					add = {
						title:			$('title').text(),
						objectId:		ep.config.objectId,
						viewAction:		ep.config.viewAction
					};
				}
				if( !add.title ){
					add.title = '';
				}
				add.id = add.objectId + ':' + add.viewAction;

				// remove duplicate
				$.each( historyData, function( i, data ){
					if( data.id == add.id ){
						historyData.splice(i,1);
						return false;
					}
				});

				historyData.unshift(add);
				historyData = historyData.splice(0,40);
				historySave();
			},

			get: function( i ){
				return i===undef ? historyData : historyData[i];
			},

			remove: function( i ){
				historyData = i===undef ? [] : historyData.splice( i, 1 );
				historySave();
			},

			removeByObjectId: function( objectId ){
				for( var i=0,iLength=historyData.length ; i<iLength ; i++ ){
					var historyItem = historyData[i];

					if( historyItem.objectId === objectId ){
						historyData.splice(i,1);
						i--;
						iLength--;
					}
				};
				historySave();
			}

		});

	historyHandle.add();

	return de_epages;

});