/*
 * @copyright		Copyright 2006-2011, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.seo.ui.seoGaugeWidget
 *
 * @revision		$Revision: 1.5 $
 */

define( "de_epages/seo/ui/seogaugewidget", [
	"jquery",
	"de_epages",
	"$tmpl!./seogaugewidget",

	"jquery/ui/widget"
], function( $, de_epages, tmplSeoGaugeWidget ){

	$.widget( "ui.seoUiSeoGaugeWidget", {

		options: {
			seoQuality: 0,				// SEO quality attribute of the object [ 0 .. 100 ]. 0 means no SEO check has been done yet.
			showStatusImage: true,
			caption : 'SEO:',
			deactivated : false
		},

		_create: function() {
			this._applyTmpl();
		},

		_applyTmpl: function() {
			var percentage = this.options.seoQuality;
      var percentageClass;

	    if(percentage < 33) {
	        percentageClass = 'red';
	    } else if(percentage < 66) {
	        percentageClass = 'orange';
	    } else if(percentage < 100) {
	        percentageClass = 'yellow';
	    } else {
	        percentageClass = 'green';
	    }

			var statusClass;
			if(this.options.deactivated) {
				statusClass = 'de_epages-seoUiSeoGaugeWidget-itemStatusDeactivated';
			} else if(percentage === 0) {
				statusClass = 'de_epages-seoUiSeoGaugeWidget-itemStatusUnknown';
			} else {
				statusClass = 'de_epages-seoUiSeoGaugeWidget-itemStatusKnown';
			}

			this.element.empty().append(
				tmplSeoGaugeWidget( [{
					statusClass : statusClass,
					caption : this.options.caption,
					percentage : percentage,
          percentageClass : percentageClass,
					statusDisplay : this.options.showStatusImage ? '' : 'HideElement'
				}])
			);
		},

		showStatusImage: function(state) {
			this.options.showStatusImage = state;
			this._applyTmpl();
		},

		setPercentage: function(newValue) {
			this.options.seoQuality = newValue;
			this._applyTmpl();
		},

		setDeactivated: function(newValue) {
			this.options.deactivated = newValue;
			this._applyTmpl();
		}

	});

	return de_epages;

});
