/*
 * @copyright		Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @odule			de_epages.shop.ui.userBlogWidget
 *
 * @evision		$Revision: 1.6 $
 */

define( "de_epages/shop/ui/userblogwidget", [
	"jquery",
	"ep",
	"de_epages",
	"util/string",
	"$tmpl!./userblogwidget",

	"jquery/i18n",
	"ep/date",
	"ep/ui/tooltip",
	"ep/fn/busy",
	"de_epages/presentation/rss"
], function( $, ep, de_epages, str, tmplUserBlogWidget ){

	$.widget( "ui.shopUiUserBlogWidget", {

		options: { //define options of widget formally know as widget properties in dojo
			url: null,
			visibleEntrys: 3,
			entryLength: 50
		},

		_create: function(){
			if(!this.options.url){
				return;
			}
			ep(this.element.parent()).busy();
			//getFeedData
			var rss = new de_epages.presentation.Rss(this.options.url, $.proxy(this,'_readFeedData'));
		},

		_readFeedData: function(feedData){
			var o = this.options,
				items = feedData.items.slice( 0, o.visibleEntrys );

			$.each( items, function(){
				this.tooltipTitle = this.title;
				this.tooltipText = this.text;
				//if(this.textEncoded){
					//var textEncoded = this.textEncoded;
					//this.tooltipText = textEncoded; //textEncoded.substring(0,textEncoded.search(/<span[\w\s"=]*id="more/)) + '</p>';
				//}

				this.tooltipDate = $.i18n.formatDate( this.pubDate, 'd', {region:ep.config.region} );
				this.title = str.shrink( this.title, {length: o.entryLength, cut: false});
				this.text = str.shrink( this.text, {length: o.entryLength, cut: false} );
			});

			entrys = tmplUserBlogWidget( {'items':items} )
				.appendTo(this.element);

			this.element
				.find('.ep-shopUiUserBlogWidget-item')
				.each(function(){
					var elem = ep(this);
					elem.find('.ep-shopUiUserBlogWidget-itemTooltip')
						.uiTooltip({
							context:	elem.find('.ep-shopUiUserBlogWidget-itemContent'),
							interactive:true,
							addClass:	'ep-shopUiUserBlogWidget-itemTooltip',
							showDelay:	1000,
							hideDelay:	200
						});
				});
				ep(this.element.parent()).busy('hide');
		},

		destroy: function(){
			this.element.remove();
		}

	});

	return de_epages;

});
