/*
 * @copyright		Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @odule			de_epages.shop.ui.userCommunityWidget
 *
 * @evision		$Revision: 1.6 $
 */

define( "de_epages/shop/ui/usercommunitywidget", [
	"jquery",
	"ep",
	"de_epages",
	"util/string",
	"$tmpl!./usercommunitywidget",

	"jquery/i18n",
	"ep/date",
	"ep/ui/tooltip",
	"ep/fn/busy",
	"de_epages/presentation/rss"
], function( $, ep, de_epages, str, tmplUserCommunityWidget ){

	$.widget( "ui.shopUiUserCommunityWidget", {

		_feedData: null,

		options: { //define options of widget formally know as widget properties in dojo
			url: null,
			visibleEntrys: 3,
			entryLength: 50
		},

		_create: function(){
			if(!this.options.url){
				return;
			}
			ep(this.element.parent()).busy();
			//getFeedData
			var rss = new de_epages.presentation.Rss(this.options.url, $.proxy(this,'_readFeedData'));
		},

		_readFeedData: function(feedData){
			var items = feedData.items.slice(0,this.options.visibleEntrys);
			for(var i = 0, iLength = items.length; i < iLength; i++){
				var item = items[i];
				item.title = str.shrink(item.title,this.options.entryLength);
				item.text = str.shrink(item.text,this.options.entryLength);
			}
			var entrys = tmplUserCommunityWidget( {'items': items} );
			entrys.appendTo(this.element);
			ep(this.element.parent()).busy('hide');
		},

		destroy: function(){
			this.element.remove();
		}

	});

	return de_epages;

});
